package net.t2code.autoresponse.Spigot.event;

import net.t2code.autoresponse.Spigot.Main;
import net.t2code.autoresponse.Spigot.config.config.Config;
import net.t2code.autoresponse.Spigot.objects.ResponsesObject;
import net.t2code.autoresponse.Spigot.system.ProxyCommandSenderReciver;
import net.t2code.autoresponse.Spigot.system.ProxySend;
import net.t2code.autoresponse.Util;
import net.t2code.t2codelib.SPIGOT.api.commands.T2C_Cmd;
import net.t2code.t2codelib.SPIGOT.api.messages.T2C_Replace;
import net.t2code.t2codelib.SPIGOT.api.messages.T2C_Send;
import net.t2code.t2codelib.SPIGOT.api.plugins.T2C_PluginCheck;
import net.t2code.t2codelib.SPIGOT.system.config.config.T2C_LibConfig;
import org.bukkit.Bukkit;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.player.AsyncPlayerChatEvent;
import org.bukkit.scheduler.BukkitRunnable;

public class ResponseListener implements Listener {

    @EventHandler
    public static void ChatListener(AsyncPlayerChatEvent e) {
        Player player = e.getPlayer();
       /* boolean bool = false;
        for (String s : Main.allResponse) {
            if (e.getMessage().contains(s)) bool = true;
        }
        if (!bool) return;

        */
            for (ResponsesObject response : Main.allResponses) {
            if (!response.permNecessary || player.hasPermission(response.permission)) {
                if (response.contains) {
                    for (String responseKey : response.responseKeys) {
                        if (responseKey.contains(Config.VALUES.keywordSeparation.getValue().toString())) {
                            String[] key = responseKey.split(Config.VALUES.keywordSeparation.getValue().toString());
                            boolean allContains = false;
                            for (String s : key) {
                                if (e.getMessage().toLowerCase().contains(s.toLowerCase())) {
                                    allContains = true;
                                } else return;
                            }
                            if (allContains) {
                                execute1(e, player, response, responseKey);
                                return;
                            }
                        } else if (e.getMessage().toLowerCase().contains(responseKey.toLowerCase())) {
                            execute1(e, player, response, responseKey);
                            return;
                        }
                    }
                } else {
                    for (String responseKey : response.responseKeys) {
                        if (e.getMessage().equalsIgnoreCase(responseKey)) {
                            execute1(e, player, response, responseKey);
                            return;
                        }
                    }
                }
            }
        }
    }

    private static void execute1(AsyncPlayerChatEvent e, Player player, ResponsesObject response, String responseKey) {
        if (response.protectionGameModeEnable) {
            if (response.protectionGameModeMode.equalsIgnoreCase("blacklist") && response.protectionGameModeList.contains(player.getGameMode().toString())) {
                return;
            }
            if (response.protectionGameModeMode.equalsIgnoreCase("whitelist") && !response.protectionGameModeList.contains(player.getGameMode().toString())) {
                return;
            }
        }
        if (response.protectionWorldEnable) {
            if (response.protectionWorldMode.equalsIgnoreCase("blacklist") && response.protectionWorldList.contains(player.getWorld().getName())) {
                return;
            }
            if (response.protectionWorldMode.equalsIgnoreCase("whitelist") && !response.protectionWorldList.contains(player.getWorld().getName())) {
                return;
            }
        }
        use(e, player, responseKey, response);
        Bukkit.getScheduler().runTaskLaterAsynchronously(Main.getPlugin(), () -> {
            if (response.async) {
                executeAsync(player, response);
            } else executeSync(player, response);
        }, 2L);
    }

    private static void executeSync(Player player, ResponsesObject response) {
        Bukkit.getScheduler().runTaskLater(Main.getPlugin(), () -> executeFinal(player, response), (long) response.delayInTicks);
    }

    private static void executeAsync(Player player, ResponsesObject response) {
        Bukkit.getScheduler().runTaskLaterAsynchronously(Main.getPlugin(), () -> executeFinal(player, response), (long) response.delayInTicks);
    }

    private static void executeFinal(Player player, ResponsesObject response) {
        if (response.commandEnable) {
            for (String cmd : response.command) {
                if (response.bungeeCommand) {
                    if ((boolean) T2C_LibConfig.VALUES.proxy.getValue()) {
                        if (response.commandAsConsole) {
                            ProxyCommandSenderReciver.sendToBungee(player, cmd.replace("[player]", player.getName()), ProxySend.BUNGEECOMMAND);
                        } else ProxyCommandSenderReciver.sendToBungee(player, cmd.replace("[player]", player.getName()), ProxySend.COMMAND);
                    } else {
                        T2C_Send.console(Util.getPrefix() + " §4To use bungee commands, enable the Bungee option in the config.");
                        T2C_Send.sender(player, Util.getPrefix() + " §4To use bungee commands, enable the Bungee option in the config.");
                    }
                } else {
                    if (response.commandAsConsole) {
                        new BukkitRunnable() {
                            @Override
                            public void run() {
                                T2C_Cmd.console(cmd.replace("[player]", player.getName()));
                            }
                        }.runTaskLater(Main.getPlugin(), 1L);

                    } else {
                        T2C_Cmd.player(player, cmd.replace("[player]", player.getName()));
                    }
                }
            }
        }
        if (response.messageEnable) {
            for (String msg : response.messages) {
                String text;
                if (T2C_PluginCheck.papi()) {
                    text = T2C_Replace.replace(Util.getPrefix(), player, msg);
                } else {
                    text = T2C_Replace.replace(Util.getPrefix(), msg);
                }
                if (response.messageGlobal) {
                    if (response.messageGlobalBungee) {
                        ProxyCommandSenderReciver.sendToBungee(player, text, ProxySend.ALLPLAYERMSG);
                    } else {
                        for (Player player1 : Bukkit.getOnlinePlayers()) {
                            T2C_Send.player(player1, text);
                        }
                    }
                } else T2C_Send.player(player, text);
            }
        }
    }

    private static void use(AsyncPlayerChatEvent e, Player player, String responseKey, ResponsesObject response) {
        if (response.blockKeyMessage) e.setCancelled(true);
        if ((boolean) Config.VALUES.logConsole.getValue()) T2C_Send.console(Util.getPrefix() + " §6Player: §e" + player.getName() + " §6use AutoResponse: §e" + responseKey);
    }
}
