package net.t2code.autoresponse.Spigot.system;

import net.t2code.autoresponse.Spigot.Main;
import net.t2code.autoresponse.Spigot.config.config.Config;
import net.t2code.autoresponse.Spigot.config.languages.Languages;
import net.t2code.autoresponse.Spigot.config.response.ResponseFile;
import net.t2code.autoresponse.Util;
import net.t2code.autoresponse.Spigot.cmdManagement.CmdExecuter;
import net.t2code.autoresponse.Spigot.event.ResponseListener;
import net.t2code.t2codelib.SPIGOT.api.messages.T2C_Template;
import net.t2code.t2codelib.SPIGOT.api.update.T2C_UpdateAPI;
import net.t2code.t2codelib.SPIGOT.system.config.config.T2C_LibConfig;
import org.bukkit.Bukkit;

import java.util.List;

public class Load {
    static Main plugin = Main.getPlugin();

    public static void onLoad(String prefix, List<String> autor, String version, String spigot, int spigotID, String discord, int bstatsID) {
        Long long_ = T2C_Template.onLoadHeader(prefix, autor, version, spigot, discord);
        plugin.getCommand("t2code-autoresponse").setExecutor(new CmdExecuter());

        loadReload(false);
        T2C_UpdateAPI.onUpdateCheck(plugin, prefix, Util.getGit(), spigotID, discord,
                (boolean) Config.VALUES.updateCheckOnJoin.getValue(), (boolean) Config.VALUES.updateCheckSeePreReleaseUpdates.getValue(), (int) Config.VALUES.updateCheckTimeInterval.getValue());
        Bukkit.getServer().getPluginManager().registerEvents(new JoinEvent(), plugin);
        Bukkit.getServer().getPluginManager().registerEvents(new ResponseListener(), plugin);

        T2C_Template.onLoadFooter(prefix, long_);
        Metrics.Bstats(plugin, bstatsID);
        if ((boolean) T2C_LibConfig.VALUES.proxy.getValue()) {
            plugin.getServer().getMessenger().registerOutgoingPluginChannel(plugin, "BungeeCord");
            Bukkit.getMessenger().registerOutgoingPluginChannel(plugin, "t2car:bungee");
        }
        Permissions.register();
    }

    public static void loadReload(boolean isReload) {
        Config.set(isReload);
        Languages.set(isReload);
        ResponseFile.set(isReload);
    }
}
